<template xmlns:v-hammer="http://www.w3.org/1999/xhtml">
  <div id="app">
    <div
      class="viewport"
      ref="viewport"
      v-hammer:panstart="onPanStart"
      v-hammer:pan="onPan"
      v-hammer:panend="onPanEnd"
    >
      <div
        ref="list"
        class="votes"
        :class="{ 'scroll-to-edge': scrollToViewportEdgeTransition }"
        :style="{ transform: `translate3d(${-scrollLeft}px, 0px, 0px)` }"
      >
        <a
          v-for="vote in votes"
          :key="vote.id"
          :href="`${BASE_TLD}/votes/${vote.id}`"
          class="vote"
          target="_blank"
          rel="noopener nofollow"
          draggable="false"
          :style="{
            width: `${itemWidth}px`,
            flexBasis: `${itemWidth}px`,
            marginRight: `${spaceBetween}px`,
          }"
        >
          <article class="vote__content">
            <header class="vote__header">
              <div class="meta">
                <div class="period">
                  <icon name="calendar-clock"></icon>
                  <span
                    >c {{ getHumanDate(vote.date) }} по
                    {{ getHumanDate(vote.expire) }}</span
                  >
                </div>
                <div class="voted-count">
                  <icon name="account-multiple"></icon> <span>{{ vote.count }}</span>
                </div>
              </div>
              <div
                v-if="vote.thumbnail"
                class="thumbnail"
                :style="{ backgroundImage: `url('${vote.thumbnail.url}')` }"
              >
                <!--
                  У object-fit поддержка не самая лучшая.
                  Поэтому визуально изображение показывается через `background` с `cover`-позиционированием.
                  При этом `img` убирать не нужно - визуально оно скрыто, но:
                    - поисковики его увидят,
                    - у пользователей будет доступ к изображению через контекстное меню,
                    - поддержка IE10+
                -->
                <img :src="vote.thumbnail.url" :alt="vote.title" />
              </div>
            </header>
            <main class="vote__body">
              <h2 class="title">{{ vote.title }}</h2>
              <p class="description">{{ vote.teaser }}</p>
            </main>
            <footer class="vote__footer">
              <div class="link-next">Далее <icon name="arrow-right"></icon></div>
            </footer>
          </article>
        </a>
      </div>
    </div>

    <p>Загружено: {{ votes.length }}</p>
    <p v-show="isPending">Загрузка...</p>
  </div>
</template>

<script src="./index.js"></script>
<style lang="scss">
@import '~normalize.css/normalize.css';

html {
  min-height: 100%;
}
body {
  height: 100%;
}
html,
body {
  font-family: Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  overflow-x: hidden;
  box-sizing: border-box;
  background-color: #f7f6f8;
}

*,
*:before,
*:after {
  box-sizing: inherit;
}
</style>
<style src="./index.scss" lang="scss" scoped></style>
